#!/usr/bin/python
# -*- coding: utf-8 -*-

#Clases que gestionan la selección
#Copyright (C) 2006  Inmaculada Luengo Merino, Néstor Arocha Rodríguez

#This file is part of Driza.
#
#Driza is free software; you can redistribute it and/or modify
#it under the terms of the GNU General Public License as published by
#the Free Software Foundation; either version 2 of the License, or
#(at your option) any later version.
#
#Driza is distributed in the hope that it will be useful,
#but WITHOUT ANY WARRANTY; without even the implied warranty of
#MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#GNU General Public License for more details.
#
#You should have received a copy of the GNU General Public License
#along with Driza; if not, write to the Free Software
#Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

from qt import *
from Driza.widgets.widgetsqt import ListBoxListaSimple
from Driza.widgets.widgetsqt import ListBoxListaDoble
from Driza.widgets.widgetsqt import ListBoxDobleComboBoxListBoxListaDoble
from Driza.clasesbase import ElementoWidgetOperacion


image0_data = [
"23 20 2 1",
"# c #313031",
". c #ffffff",
".......................",
".......................",
"......##...............",
"......#.#..............",
"......#..#.............",
"......#...#............",
"......#....#...........",
"......#.....#..........",
"......#......#.........",
"......#.......#........",
"......#.......#........",
"......#......#.........",
"......#.....#..........",
"......#....#...........",
"......#...#............",
"......#..#.............",
"......#.#..............",
"......##...............",
".......................",
"......................."
]
image1_data = [
"23 20 2 1",
"# c #313031",
". c #ffffff",
".......................",
".......................",
"...............##......",
"..............#.#......",
".............#..#......",
"............#...#......",
"...........#....#......",
"..........#.....#......",
".........#......#......",
"........#.......#......",
"........#.......#......",
".........#......#......",
"..........#.....#......",
"...........#....#......",
"............#...#......",
".............#..#......",
"..............#.#......",
"...............##......",
".......................",
"......................."
]

class SelectorVariableEstudio(ElementoWidgetOperacion,QWidget):
	"""Clase padre de los selectores. Los selectores permiten elegir una o más variables, o una variable y un valor de esa variable, etc
	
	Las clases hijas deben suministrar self.cajadisponible,addelemento
	"""
	def __init__(self,parent,dato,cajadisponible):
		#VARIABLES PUBLICAS
		QWidget.__init__(self,parent,"selector",0)

		self.image0 = QPixmap(image0_data)
		self.image1 = QPixmap(image1_data)

		WSelectorSimpleLayout = QHBoxLayout(self,11,6,"WSelectorSimpleLayout")
		layout2 = QVBoxLayout(None,0,6,"layout2")
		self.widgetStack1=QWidgetStack(self,"staaack")
		self.widgetStack1.addWidget(cajadisponible)
		self.widgetStack1.raiseWidget(cajadisponible)
		self.widgetStack1.setSizePolicy(QSizePolicy(QSizePolicy.Expanding,QSizePolicy.Expanding,0,0,self.widgetStack1.sizePolicy().hasHeightForWidth()))
		#self.widgetStack1.setMinimumSize(QSize(0,60))
		#self.widgetStack1.setMaximumSize(QSize(32767,600))
		self.cajadisponible=cajadisponible
		#self.cajadisponible.setMinimumSize(QSize(0,60))
		#self.cajadisponible.setMaximumSize(QSize(32767,600))
		layout2.addWidget(self.widgetStack1)
		WSelectorSimpleLayout.addLayout(layout2)
		
		layout1 = QVBoxLayout(None,0,6,"layout1")
		
		self.pushButton1 = QPushButton(self,"pushButton1")
		self.pushButton1.setMaximumSize(QSize(30,30))
		self.pushButton1.setPixmap(self.image0)
		layout1.addWidget(self.pushButton1)
		spacer1 = QSpacerItem(30,122,QSizePolicy.Minimum,QSizePolicy.Expanding)
		layout1.addItem(spacer1)
		
		self.pushButton2 = QPushButton(self,"pushButton2")
		self.pushButton2.setMaximumSize(QSize(30,30))
		self.pushButton2.setPixmap(self.image1)
		layout1.addWidget(self.pushButton2)
		WSelectorSimpleLayout.addLayout(layout1)
		
		layout3 = QVBoxLayout(None,0,6,"layout3")
		
		self.textLabel2 = QLabel(self,"textLabel2")
		layout3.addWidget(self.textLabel2)
		
		self.cajaseleccion = QListBox(self,"cajaseleccion")
		self.cajaseleccion.setMinimumSize(QSize(0,60))
		layout3.addWidget(self.cajaseleccion)
		WSelectorSimpleLayout.addLayout(layout3)
		self.cajaseleccion.setSizePolicy(QSizePolicy(QSizePolicy.Expanding,QSizePolicy.Expanding,0,0,self.cajaseleccion.sizePolicy().hasHeightForWidth()))
		
		self.setCaption("Form1")
		self.textLabel2.setText(u"Selección")
		
		self.resize(QSize(294,240).expandedTo(self.minimumSizeHint()))
		self.clearWState(Qt.WState_Polished)
		self.__conexiones()
		#Miembros !qt
		self.seleccion=[]
		self.parent=parent
		self.dato=dato

	def showEvent(self,ev):
		self.actualizarcajas()
		QWidget.showEvent(self,ev)

	def __conexiones(self):
		"""Establece las conexiones entre elementos"""
		self.connect(self.pushButton1,SIGNAL("clicked()"),self.addelemento)
		self.connect(self.pushButton2,SIGNAL("clicked()"),self.delelemento)

	def actualizarcajas(self):
		self.cajaseleccion.clear()
		for valor in self.seleccion:
			self.cajaseleccion.insertItem(str(valor))
		self.updatecajadisponible()


	def delelemento(self):
		"""Borra el elemento seleccionado en lacaja de seleccion"""
		if self.cajaseleccion.currentText():
			del self.seleccion[self.cajaseleccion.currentItem()]
			self.actualizarcajas()
	

class Selectorsimple(SelectorVariableEstudio):
	"""Este selector posee dos cajas y dos botones, que son pasados en la inicialización. Una de las cajas almacena todas las posibilidades,mientras que la otra almacena la seleccion"""
	def __init__(self,padre,dato):
		"""Clase de inicialización, almacena los componentes"""
		SelectorVariableEstudio.__init__(self,padre,dato,ListBoxListaSimple(None,"Variables"))

	#FUNCIONES PUBLICAS
	
	def addelemento(self):
		"""Añade un elemento de la seleccion de la cajadisponible"""
		if self.cajadisponible.caja.currentText():
			self.seleccion.append(self.cajadisponible.caja.currentText().latin1())
			self.actualizarcajas()

	def updatecajadisponible(self):
		lista=[]
		for var in self.dato.arrTit(factores=False):
			if not var in self.seleccion:
				lista.append(var)
		self.cajadisponible.caja.lista=lista
		self.cajadisponible.caja.myUpdate()


class Selectordoble(SelectorVariableEstudio):
	"""Este selector posee tres cajas y dos botones, que son pasados en la inicialización. Una de las cajas almacena todas las posibilidades,mientras que la otra almacena la seleccion"""

	def __init__(self,padre,dato):
		"""Clase de inicialización, almacena los componentes"""
		SelectorVariableEstudio.__init__(self,padre,dato,ListBoxListaDoble(None,"Variable1","Variable2"))

	def addelemento(self):
		"""Añade un elemento de la seleccion de la cajadisponible"""
		if self.cajadisponible.caja1.currentText() and self.cajadisponible.caja2.currentText():
			self.seleccion.append([self.cajadisponible.caja1.currentText().latin1(),self.cajadisponible.caja2.currentText().latin1()])
			self.actualizarcajas()

	def updatecajadisponible(self):
		lista=[]
		for var in self.dato.arrTit(factores=False):
			if not var in self.seleccion:
				lista.append(var)
		self.cajadisponible.caja1.lista=lista
		self.cajadisponible.caja2.lista=lista
		self.cajadisponible.caja1.myUpdate()
		self.cajadisponible.caja2.myUpdate()


class SelectorVariableValor(SelectorVariableEstudio):
	"""Permite escoger varias parejas variable-valor en vez de solamente variables. Utilizadas en las proporciones"""
	def __init__(self,padre,dato):
		"""Clase de inicialización, almacena los componentes"""
		SelectorVariableEstudio.__init__(self,padre,dato,ListBoxListaDoble(None,"Variable","Caso"))
		#uiselectordoble.WSelectorDoble.__init__(self,padre)
		self.textLabel2.setText("<b>Caso de la variable</b>")
		self.connect(self.cajadisponible.caja1,SIGNAL("selectionChanged()"),self.updatecaja2)

	def addelemento(self):
		"""Añade un elemento de la seleccion de la cajadisponible"""
		if self.cajadisponible.caja1.currentText() and self.cajadisponible.caja2.currentText():
			self.seleccion.append([self.cajadisponible.caja1.currentText().latin1(),self.cajadisponible.caja2.currentText().latin1()])
			self.actualizarcajas()

	def updatecajadisponible(self):
		lista=[]
		for var in self.dato.arrTit(factores=False):
			if not var in self.seleccion:
				lista.append(var)
		self.cajadisponible.caja1.lista=lista
		self.updatecaja2()
		self.cajadisponible.caja1.myUpdate()


	def updatecaja2(self):
		listacasos=[str(x) for x in self.dato.getCasos(self.cajadisponible.caja1.currentText().latin1())]
		self.cajadisponible.caja2.lista=listacasos
		self.cajadisponible.caja2.myUpdate()


class Selector2Variable3Valor(SelectorVariableEstudio):
	"""Permite escoger varias parejas variable-valor en vez de solamente variables. Utilizadas en las proporciones"""
	def __init__(self,padre,dato):
		"""Clase de inicialización, almacena los componentes"""
		SelectorVariableEstudio.__init__(self,padre,dato,ListBoxDobleComboBoxListBoxListaDoble(None,"Variable","Caso","Variable4"))
		self.textLabel2.setText("<b>Caso de la variable</b>")
		self.connect(self.cajadisponible.zona1.caja1,SIGNAL("selectionChanged()"),self.updatecaja2)
		self.connect(self.cajadisponible.zona2.caja,SIGNAL("selectionChanged()"),self.updatecombos)

	def addelemento(self):
		"""Añade un elemento de la seleccion de la cajadisponible"""
		if self.cajadisponible.zona1.caja1.currentText() and self.cajadisponible.zona1.caja2.currentText() and self.cajadisponible.zona2.caja.currentText():
			array1=[self.cajadisponible.zona1.caja1.currentText().latin1(),self.cajadisponible.zona1.caja2.currentText().latin1()]
			array2=[self.cajadisponible.zona2.caja.currentText().latin1(),self.cajadisponible.zona2.combo1.currentText().latin1(),self.cajadisponible.zona2.combo2.currentText().latin1()]
			self.seleccion.append([array1,array2])
			self.actualizarcajas()

	def updatecajadisponible(self):
		lista=[]
		for var in self.dato.arrTit(factores=False):
			if not var in self.seleccion:
				lista.append(var)
		self.cajadisponible.zona1.caja1.lista=lista
		self.cajadisponible.zona2.caja.lista=lista
		self.updatecaja2()
		self.cajadisponible.zona1.caja1.myUpdate()
		self.cajadisponible.zona2.caja.myUpdate()


	def updatecaja2(self):
		listacasos=[str(x) for x in self.dato.getCasos(self.cajadisponible.zona1.caja1.currentText().latin1())]
		self.cajadisponible.zona1.caja2.lista=listacasos
		self.cajadisponible.zona1.caja2.myUpdate()

	def updatecombos(self):
		listacasos=[str(x) for x in self.dato.getCasos(self.cajadisponible.zona2.caja.currentText().latin1())]
		self.cajadisponible.zona2.combo1.lista=listacasos
		self.cajadisponible.zona2.combo2.lista=listacasos
		self.cajadisponible.zona2.combo1.myUpdate()
		self.cajadisponible.zona2.combo2.myUpdate()


